treeGame.settingsMenu = function(game){
	
    this.game = game;		//	a reference to the currently running game
    this.add;		        //	used to add sprites, text, groups, etc
    this.camera;	        //	a reference to the game camera
    this.cache;		        //	the game cache
    this.input;		        //	the global input manager (you can access this.input.keyboard, this.input.mouse, as well from it)
    this.load;		        //	for preloading assets
    this.math;		        //	lots of useful common math operations
    this.sound;		        //	the sound manager - add a sound, play one, set-up markers, etc
    this.stage;		        //	the game stage
    this.time;		        //	the clock
    this.tweens;	        //	the tween manager
    this.world;		        //	the game world
    this.particles;	        //	the particle manager
    this.physics;	        //	the physics manager
    this.rnd;		        //	the repeatable random number generator
   
	settingsMenu = this;
		
	treeGame.bmd = null;
	
	treeGame.background = null;
	treeGame.overlayTexture = null;
	
}

treeGame.settingsMenu.prototype = {
	
	preload: function(){
		
			// Object Arrays
			treeGame.mountains = [];
			treeGame.clouds = [];
		
		
			// Define Cloud
			treeGame.cloud = function (index, x, y) 
			{			
		        this.index = index;
		        
		        this.randomSprite = settingsMenu.rnd.integerInRange(0, 3);
				if (this.randomSprite == 0)
				{
					this.cloudSprite = settingsMenu.add.sprite(x, y, 'textureAtlas', 'cloud1');
				} else if (this.randomSprite == 1) {
					this.cloudSprite = settingsMenu.add.sprite(x, y, 'textureAtlas', 'cloud2');
				} else if (this.randomSprite == 2) {
					this.cloudSprite = settingsMenu.add.sprite(x, y, 'textureAtlas', 'cloud3');
				} else if (this.randomSprite == 3) {
					this.cloudSprite = settingsMenu.add.sprite(x, y, 'textureAtlas', 'cloud4');
				} else {
					this.cloudSprite = settingsMenu.add.sprite(x, y, 'textureAtlas', 'cloud1');
				}
				
				this.cloudSprite.alpha = .5;
		
		        settingsMenu.physics.enable(this.cloudSprite, Phaser.Physics.ARCADE);
				this.cloudSprite.body.enable = true;
				this.cloudSprite.body.collideWorldBounds = false;
		        this.cloudSprite.body.drag.x = 500;
		        this.cloudSprite.body.drag.y = 500;
		        this.cloudSprite.anchor.setTo(0.5, 0.5);
		        
		        this.randomSpeedVariation = settingsMenu.rnd.integerInRange(-50, 50);
		       
		        // Add the cloud to the cloud group
		        cloudGroup.add(this.cloudSprite);
		        
		        // Make it rain
				this.rainEmitter = settingsMenu.add.emitter(0, 0, 50);
				this.rainEmitter.width = this.cloudSprite.width;
				this.rainEmitter.angle = 0;
				this.rainEmitter.alpha = 0.25; 
				this.rainEmitter.makeParticles('textureAtlas', 'rain');
				this.rainEmitter.minParticleScale = 0.1;
				this.rainEmitter.maxParticleScale = 1;
				this.rainEmitter.setYSpeed(300, 500);
				this.rainEmitter.setXSpeed(-5, 5);
				this.rainEmitter.minRotation = 0;
				this.rainEmitter.maxRotation = 0;
				this.rainEmitter.start(false, 2000, 150, 0);
				backgroundEmitterGroup.add(this.rainEmitter);
				this.rainEmitter.alignIn(this.cloudSprite, Phaser.CENTER);
				
			}
			
			// Define Mountain
			treeGame.mountain = function (index, x, y, width, height, alpha, key) 
			{			
			    this.mountainSprite = settingsMenu.add.tileSprite(x, y, width, height, key);
		        this.mountainSprite.alpha = alpha;
		        
		        this.mountainSprite.fixedToCamera = true;
		        
		        // Add the sky to the sky group
		        mountainGroup.add(this.mountainSprite);		               	
			}

	},

  	create: function(){
	  	
	  	// Viewport Scaling
		this.game.scale.startFullScreen(false);
		this.game.scale.scaleMode = Phaser.ScaleManager.RESIZE;
		this.game.scale.pageAlignHorizontally = true;
		this.game.scale.pageAlignVertically = true;
		this.game.scale.refresh();
		
		// Fullscreen Hotkey
		var fullscreenKey = this.game.input.keyboard.addKey(Phaser.Keyboard.F);	
	    fullscreenKey.onDown.add(this.goFull, this);
	    
	    
	    // Create Groups (Background to Foreground)
	    backgroundGradientGroup = settingsMenu.add.group();
	    cloudGroup = settingsMenu.add.group();
	    mountainGroup = settingsMenu.add.group();
	    backgroundEmitterGroup = settingsMenu.add.group();
	    
	    
		// Background
	  	treeGame.bmd = settingsMenu.make.bitmapData(window.innerWidth, window.innerHeight);
	  	treeGame.bmd.addToWorld();
	  	
	    //  Create Background Circles
/*
	    outerCircle = new Phaser.Circle((window.innerWidth)/2, (window.innerHeight)*.25, window.innerWidth);
	    innerCircle = new Phaser.Circle((window.innerWidth)/2, (window.innerHeight)*.25, 300);


	  	
		var backgroundGradient = treeGame.bmd.context.createRadialGradient(innerCircle.x, innerCircle.y, innerCircle.radius, outerCircle.x, outerCircle.y, outerCircle.radius);
		backgroundGradient.addColorStop(0, '#cfded6');
		backgroundGradient.addColorStop(1, '#C0D9DD');
		
	    treeGame.bmd.cls();
	    treeGame.bmd.circle(outerCircle.x, outerCircle.y, outerCircle.radius, backgroundGradient);
*/
	  	
/*
	  	this.titleLogo = this.add.sprite(((window.innerWidth)/2), ((window.innerHeight) * .25), 'titleImage');
	    this.titleLogo.anchor.setTo(0.5,0.5);
	    this.titleLogo.alpha = 0;
	    this.add.tween(this.titleLogo).to( { alpha: 1 }, 1000, Phaser.Easing.Quadratic.InOut, true);
*/
			
		// Menu Background Emitter
		this.leafAndSeedEmitter = settingsMenu.add.emitter(0, 0, 25);
		this.leafAndSeedEmitter.width = window.innerWidth*2;
		this.leafAndSeedEmitter.angle = 0;
		this.leafAndSeedEmitter.alpha = .25; 
		this.leafAndSeedEmitter.makeParticles('textureAtlas', ['leafOak', 'seedPine', 'seedOak', 'seedBirch', 'seedBeech', 'leafWillow', 'leafBeech', 'pineNeedles', 'leafBirch']);
/*
		this.leafAndSeedEmitter.minParticleScale = 0.5;
		this.leafAndSeedEmitter.maxParticleScale = 1;
*/
		this.leafAndSeedEmitter.setYSpeed(2, 5);
		this.leafAndSeedEmitter.setXSpeed(-15, 15);
		this.leafAndSeedEmitter.minRotation = -250;
		this.leafAndSeedEmitter.maxRotation = 250;
		this.leafAndSeedEmitter.start(false, 5000, 400, 0);
		backgroundEmitterGroup.add(this.leafAndSeedEmitter);
	    
		// Create Clouds
		
        for (var i = 0; i < 3; i++)
	    {
		    var yRandomVariation = settingsMenu.rnd.integerInRange(-200, 200);
            treeGame.clouds.push( new treeGame.cloud(treeGame.clouds.length, this.world.randomX, 300 + yRandomVariation, 1));
	    }		    
	    this.leavesSprite = this.add.sprite((window.innerWidth)/2, (window.innerHeight)/2, 'loadingBarImage');
		this.leavesSprite.anchor.setTo(0.5,0.5);
		this.add.tween(this.leavesSprite).to( { alpha: 1 }, 1000, Phaser.Easing.Quadratic.InOut, true);
		this.add.tween(this.leavesSprite).to( { y: (window.innerHeight)/4 }, 1000, Phaser.Easing.Quadratic.InOut, true);
	    
	    // Create Mountains
        treeGame.mountains.push( new treeGame.mountain(treeGame.mountains.length, 0, 0, this.game.world.width, this.game.world.height, .25, 'mountainImage'));

	    
	    this.createText();
	        
		var texture = settingsMenu.add.tileSprite(0,0,4000,4000,'textureImage');
        texture.blendMode = Phaser.blendModes.COLOR_BURN;
        texture.alpha = .35;

		overlayTexture = settingsMenu.add.group();
		overlayTexture.add(texture);
	    
	},
	
	update: function(){
		
		// Cloud Movement
		
		for (var i = 0; i < treeGame.clouds.length; i++)
		{ 
            treeGame.clouds.forEach(function (cloud) {
	            settingsMenu.world.wrap(cloud.cloudSprite, 100, false);
                settingsMenu.physics.arcade.velocityFromAngle(0, 100 + cloud.randomSpeedVariation, cloud.cloudSprite.body.velocity);
                cloud.rainEmitter.x = cloud.cloudSprite.body.x + cloud.cloudSprite.width/2;
            });
        }
	},
	
	createText: function(){
		
		
		// Day/Night Cycle Toggle
		this.dayNightCycleText = this.add.text(((window.innerWidth)/4), (window.innerHeight)/3 + ((window.innerHeight) * .05), "Toggle Day/Night Cycle", this.fontStyle);
		this.dayNightCycleText.align = 'center';
	    this.dayNightCycleText.fill = '#5b5760';
	    this.dayNightCycleText.anchor.setTo(0.5);
	    this.dayNightCycleText.font = 'Palatino';
	    this.dayNightCycleText.fontSize = 30;
	    this.dayNightCycleText.alpha = 0;
	    this.add.tween(this.dayNightCycleText).to( { alpha: 1 }, 1500, Phaser.Easing.Quadratic.InOut, true);
	    this.dayNightCycleText.padding.set(10, 16);
	    this.dayNightCycleText.inputEnabled = true;
	    this.dayNightCycleText.events.onInputOver.add(this.textOverDayNightCycle, this);
	    this.dayNightCycleText.events.onInputOut.add(this.textOutDayNightCycle, this);
	    this.dayNightCycleText.events.onInputUp.add(this.textUpDayNightCycle, this);
	    
	    if (this.game.device.android) {
			this.dayNightCycleStatusText = this.add.text(((window.innerWidth)*.75), (window.innerHeight)/3 + ((window.innerHeight) * .05), "Off", this.fontStyle);	    
		} else
	    {
			this.dayNightCycleStatusText = this.add.text(((window.innerWidth)*.75), (window.innerHeight)/3 + ((window.innerHeight) * .05), "On", this.fontStyle);	    
		}    
		this.dayNightCycleStatusText.align = 'center';
	    this.dayNightCycleStatusText.fill = '#5b5760';
	    this.dayNightCycleStatusText.anchor.setTo(0.5);
	    this.dayNightCycleStatusText.font = 'Palatino';
	    this.dayNightCycleStatusText.fontSize = 30;
	    this.dayNightCycleStatusText.alpha = 0;
	    this.add.tween(this.dayNightCycleStatusText).to( { alpha: 1 }, 1500, Phaser.Easing.Quadratic.InOut, true);
	    this.dayNightCycleStatusText.padding.set(10, 16);
	    this.dayNightCycleStatusText.inputEnabled = true;
	    this.dayNightCycleStatusText.events.onInputOver.add(this.textOverDayNightCycle, this);
	    this.dayNightCycleStatusText.events.onInputOut.add(this.textOutDayNightCycle, this);
	    this.dayNightCycleStatusText.events.onInputUp.add(this.textUpDayNightCycle, this);
	    
	    // Toggle Particle Effects
		this.particleEffectsText = this.add.text(((window.innerWidth)/4), (window.innerHeight)/3 + ((window.innerHeight) * .15), "Toggle Particle Effects", this.fontStyle);
		this.particleEffectsText.align = 'center';
	    this.particleEffectsText.fill = '#5b5760';
	    this.particleEffectsText.anchor.setTo(0.5);
	    this.particleEffectsText.font = 'Palatino';
	    this.particleEffectsText.fontSize = 30;
	    this.particleEffectsText.alpha = 0;
	    this.add.tween(this.particleEffectsText).to( { alpha: 1 }, 1500, Phaser.Easing.Quadratic.InOut, true);
	    this.particleEffectsText.padding.set(10, 16);
	    this.particleEffectsText.inputEnabled = true;
	    this.particleEffectsText.events.onInputOver.add(this.textOverParticleEffects, this);
	    this.particleEffectsText.events.onInputOut.add(this.textOutParticleEffects, this);
	    this.particleEffectsText.events.onInputUp.add(this.textUpParticleEffects, this);
	    
	    if (this.game.device.android) {
		    this.particleEffectsStatusText = this.add.text(((window.innerWidth)*.75), (window.innerHeight)/3 + ((window.innerHeight) * .15), "Off", this.fontStyle);
	    } else
	    {
		    this.particleEffectsStatusText = this.add.text(((window.innerWidth)*.75), (window.innerHeight)/3 + ((window.innerHeight) * .15), "On", this.fontStyle);
	    }
	    
		this.particleEffectsStatusText.align = 'center';
	    this.particleEffectsStatusText.fill = '#5b5760';
	    this.particleEffectsStatusText.anchor.setTo(0.5);
	    this.particleEffectsStatusText.font = 'Palatino';
	    this.particleEffectsStatusText.fontSize = 30;
	    this.particleEffectsStatusText.alpha = 0;
	    this.add.tween(this.particleEffectsStatusText).to( { alpha: 1 }, 1500, Phaser.Easing.Quadratic.InOut, true);
	    this.particleEffectsStatusText.padding.set(10, 16);
	    this.particleEffectsStatusText.inputEnabled = true;
	    this.particleEffectsStatusText.events.onInputOver.add(this.textOverParticleEffects, this);
	    this.particleEffectsStatusText.events.onInputOut.add(this.textOutParticleEffects, this);
	    this.particleEffectsStatusText.events.onInputUp.add(this.textUpParticleEffects, this);
	    
	    // Set Leaf Density
		this.leafDensityText = this.add.text(((window.innerWidth)/4), (window.innerHeight)/3 + ((window.innerHeight) * .25), "Leaf Density", this.fontStyle);
		this.leafDensityText.align = 'center';
	    this.leafDensityText.fill = '#5b5760';
	    this.leafDensityText.anchor.setTo(0.5);
	    this.leafDensityText.font = 'Palatino';
	    this.leafDensityText.fontSize = 30;
	    this.leafDensityText.alpha = 0;
	    this.add.tween(this.leafDensityText).to( { alpha: 1 }, 1500, Phaser.Easing.Quadratic.InOut, true);
	    this.leafDensityText.padding.set(10, 16);
	    this.leafDensityText.inputEnabled = true;
	    this.leafDensityText.events.onInputOver.add(this.textOverLeafDensity, this);
	    this.leafDensityText.events.onInputOut.add(this.textOutLeafDensity, this);
	    this.leafDensityText.events.onInputUp.add(this.textUpLeafDensity, this);
	    
	    this.leafDensityStatusText = this.add.text(((window.innerWidth)*.75), (window.innerHeight)/3 + ((window.innerHeight) * .25), "Low", this.fontStyle);
		this.leafDensityStatusText.align = 'center';
	    this.leafDensityStatusText.fill = '#5b5760';
	    this.leafDensityStatusText.anchor.setTo(0.5);
	    this.leafDensityStatusText.font = 'Palatino';
	    this.leafDensityStatusText.fontSize = 30;
	    this.leafDensityStatusText.alpha = 0;
	    this.add.tween(this.leafDensityStatusText).to( { alpha: 1 }, 1500, Phaser.Easing.Quadratic.InOut, true);
	    this.leafDensityStatusText.padding.set(10, 16);
	    this.leafDensityStatusText.inputEnabled = true;
	    this.leafDensityStatusText.events.onInputOver.add(this.textOverLeafDensity, this);
	    this.leafDensityStatusText.events.onInputOut.add(this.textOutLeafDensity, this);
	    this.leafDensityStatusText.events.onInputUp.add(this.textUpLeafDensity, this);


		// Back to Main Menu
		this.backToMainMenuText = this.add.text(((window.innerWidth)/2), window.innerHeight - ((window.innerHeight) * .15), "Back to Main Menu", this.fontStyle);
		this.backToMainMenuText.align = 'center';
	    this.backToMainMenuText.fill = '#5b5760';
	    this.backToMainMenuText.anchor.setTo(0.5);
	    this.backToMainMenuText.font = 'Palatino';
	    this.backToMainMenuText.fontSize = 30;
	    this.backToMainMenuText.alpha = 0;
	    this.add.tween(this.backToMainMenuText).to( { alpha: 1 }, 2000, Phaser.Easing.Quadratic.InOut, true);
	    this.backToMainMenuText.inputEnabled = true;
		this.backToMainMenuText.events.onInputOver.add(this.backToMainMenuTextOver, this);
	    this.backToMainMenuText.events.onInputOut.add(this.backToMainMenuTextOut, this);
	    this.backToMainMenuText.events.onInputUp.add(this.backToMainMenuTextUp, this);
	},
	
	textOutDayNightCycle: function() {
	
	    this.dayNightCycleText.fill = '#5b5760';
	    this.dayNightCycleStatusText.fill = '#5b5760';
	
	},
	
	textOverDayNightCycle: function() {
	
	    this.dayNightCycleText.fill = '#8f9250';
		this.dayNightCycleStatusText.fill = '#8f9250';
	},
		
	textUpDayNightCycle: function() {
	
	    if (this.game.dayNightCycleToggle == true)
	    {
		    this.game.dayNightCycleToggle = false;
		    settingsMenu.dayNightCycleStatusText.text = "Off";
	    } else
	    {
		    this.game.dayNightCycleToggle = true;
		    settingsMenu.dayNightCycleStatusText.text = "On";
	    }
	
	},
	
	textOutParticleEffects: function() {
	
	    this.particleEffectsText.fill = '#5b5760';
	    this.particleEffectsStatusText.fill = '#5b5760';
	
	},
	
	textOverParticleEffects: function() {
	
	    this.particleEffectsText.fill = '#8f9250';
		this.particleEffectsStatusText.fill = '#8f9250';
	},
		
	textUpParticleEffects: function() {
		
		if (this.game.particleEffectsToggle == true)
	    {
		    this.game.particleEffectsToggle = false;
		    settingsMenu.particleEffectsStatusText.text = "Off";
	    } else
	    {
		    this.game.particleEffectsToggle = true;
		    settingsMenu.particleEffectsStatusText.text = "On";
	    }
	
	},
	
	textOutLeafDensity: function() {
	
	    this.leafDensityText.fill = '#5b5760';
	    this.leafDensityStatusText.fill = '#5b5760';
	
	},
	
	textOverLeafDensity: function() {
	
	    this.leafDensityText.fill = '#8f9250';
		this.leafDensityStatusText.fill = '#8f9250';
	},
		
	textUpLeafDensity: function() {
		
		if (this.game.leafDensityToggle == "low")
	    {
		    this.game.leafDensityToggle = "high"
		    settingsMenu.leafDensityStatusText.text = "High";
	    } else
	    {
		    this.game.leafDensityToggle = "low";
		    settingsMenu.leafDensityStatusText.text = "Low";
	    }
	
	},



	backToMainMenuTextOut: function() {
	
	    this.backToMainMenuText.fill = '#5b5760';
	    this.add.tween(this.titleLeafLeftSprite).to( { alpha: 0 }, 200, Phaser.Easing.Quadratic.InOut, true);	    
	    this.add.tween(this.titleLeafRightSprite).to( { alpha: 0 }, 200, Phaser.Easing.Quadratic.InOut, true);
	
	},
	
	backToMainMenuTextOver: function() {
	
	    this.backToMainMenuText.fill = '#8f9250';
	    this.titleLeafLeftSprite = settingsMenu.add.sprite(-170, -10, 'textureAtlas', 'leafOak');
			
	    this.titleLeafRightSprite = settingsMenu.add.sprite(165, -10, 'textureAtlas', 'leafBeech');
	    
	    this.titleLeafRightSprite.angle = 180;
	    
	    this.titleLeafRightSprite.scale.y = -1;
	    
	    this.titleLeafLeftSprite.alpha = 0;
	    this.titleLeafRightSprite.alpha = 0;
	    
		this.titleLeafLeftSprite.anchor.setTo(0.5);
		this.titleLeafRightSprite.anchor.setTo(0.5);	    
	    
	    this.add.tween(this.titleLeafLeftSprite).to( { alpha: 1 }, 200, Phaser.Easing.Quadratic.InOut, true);	    
	    this.add.tween(this.titleLeafRightSprite).to( { alpha: 1 }, 200, Phaser.Easing.Quadratic.InOut, true);
	    
	    this.backToMainMenuText.addChild(this.titleLeafLeftSprite);
	    this.backToMainMenuText.addChild(this.titleLeafRightSprite);
	
	},
	
	backToMainMenuTextUp: function() {
	
	    this.game.state.start("TitleMenu");
	
	},


	
	goFull: function() 
	{
	
	    if (settingsMenu.game.scale.isFullScreen)
	    {
	        settingsMenu.game.scale.stopFullScreen();
	    }
	    else
	    {
	        settingsMenu.game.scale.startFullScreen(false);
	    }
	}
}